/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package controller;

import domain.Invoice;
import domain.Manufacturer;
import domain.Product;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import transfer.RequestObject;
import transfer.ResponseObject;
import util.Operation;
import util.ResponseStatus;

/**
 *
 * @author student1
 */
public class Controller {

    private static Controller instance;
    private Map<String, Object> map;
    private Socket socket;

    private Controller() {
        try {
            map = new HashMap<>();
            socket = new Socket("localhost", 9000);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    public static Controller getInstance() {
        if (instance == null) {
            instance = new Controller();
        }

        return instance;
    }

    public void login(String username, String password) {

    }

    public List<Manufacturer> getAllManufacturers() throws Exception {
        RequestObject request = new RequestObject();
        request.setOperation(Operation.OPERATION_GET_ALL_MANUFACTURERS);
        sendRequest(request);
        ResponseObject response = receiveResponse();
        if (response.getStatus() == ResponseStatus.SUCCESS) {
            return (List<Manufacturer>) response.getData();
        }
        throw new Exception(response.getErrorMessage());
    }

    public Product saveProduct(Product product) throws Exception {
        RequestObject request = new RequestObject();
        request.setOperation(Operation.OPERATION_SAVE_PRODUCT);
        request.setData(product);
        sendRequest(request);
        ResponseObject response = receiveResponse();
        if (response.getStatus() == ResponseStatus.SUCCESS) {
            return (Product) response.getData();
        }
        throw new Exception(response.getErrorMessage());
    }

    public List<Product> getAllProducts() throws Exception {
        return new LinkedList<>();
    }

    public void setProduct(Product product) {
        map.put("current.product", product);
    }

    public Map getMap() {
        return map;
    }

    public Invoice saveInvoice(Invoice invoice) throws Exception {
        return new Invoice();
    }

    public void sendRequest(RequestObject request) throws IOException {
        ObjectOutputStream outSocket = new ObjectOutputStream(socket.getOutputStream());
        outSocket.writeObject(request);
    }

    public ResponseObject receiveResponse() throws IOException, ClassNotFoundException {
        ObjectInputStream inSocket = new ObjectInputStream(socket.getInputStream());
        return (ResponseObject) inSocket.readObject();
    }
}
